---
title: "Spaß mit Verschlüsselung"
scripts:
    - js/kryptographie.js
---

<noscript>Diese Seite funktioniert nur mit Javascript</noscript>
<div class="cryptography flex-column">
    <div class="control-row spread-end">
        <div class="check-radio-label">
            <input
                type="radio"
                id="decryption-method-scytale"
                name="decryption-method"
                value="decryption-method-scytale"
            />
            <label for="decryption-method-scytale">Skytale</label>
        </div>
        <div class="check-radio-label">
            <input
                type="radio"
                id="decryption-method-caesar"
                name="decryption-method"
                value="decryption-method-caesar"
                checked
            />
            <label for="decryption-method-caesar">Caesar</label>
        </div>
        <div class="check-radio-label">
            <input
                type="radio"
                id="decryption-method-vigenere"
                name="decryption-method"
                value="decryption-method-vigenere"
            />
            <label for="decryption-method-vigenere">Vigenère</label>
        </div>
        <div class="check-radio-label">
            <input
                type="radio"
                id="decryption-method-evaluation"
                name="decryption-method"
                value="decryption-method-evaluation"
            />
            <label for="decryption-method-evaluation">Auswertung</label>
        </div>

        <div class="flex-row align-center">
            <select name="challenge" id="select-challenge">
                <option value="default">Aufgaben</option>
                <option value="caesar-easy">Caesar leicht</option>
                <option value="caesar-normal">Caesar mittel</option>
                <option value="caesar-hard">Caesar schwer</option>
                <option value="vigenere-easy">Vigenère leicht</option>
                <option value="vigenere-normal">Vigenère mittel</option>
                <option value="vigenere-hard">Vigenère schwer</option>
            </select>
            <button id="button-demo">Demo</button>
        </div>
    </div>

    <span class="control-column">
        <span>Geheimbotschaft:</span>
        <textarea
            id="input-deencrypt"
            placeholder="Hier kannst du die zu entschlüsselnde Botschaft reinschreiben."
            rows="5"
        >
Hqwvfkoüvvhoq pdfkw Vsdß! :-)
        </textarea>
    </span>

    <span id="output-deencrypt-container" class="control-column flex-grow-1">
        <span>Entschlüsselter Text:</span>
        <textarea id="output-deencrypt" rows="7" class="text-black-900" disabled>
Herzlich Willkommen!

Hier kannst du ein paar Verschlüsselungsexperimente durchführen.

Drücke ganz unten auf den "Los!"-Knopf und spiele selbst mit verschiedenen Eingaben herum. Probiere auch mal den "Demo"-Knopf oder die "Aufgaben" aus.

Viel Spaß wünscht dir das Team vom Augsburger Mathezirkel.
    </textarea>
    </span>

    <span
        id="output-evaluation-container"
        class="control-column flex-grow-1 justify-content-space-between d-none"
    >
        <canvas id="myChart" class="chartBox"></canvas>

        <div class="flex-row align-center width-100">
            <div class="overflow-auto width-100">
                <table>
                    <tr id="table-decryptors-row-header" class="font-size-small">
                        <th>1</th>
                        <th>2</th>
                        <th>3</th>
                        <th>4</th>
                        <th>5</th>
                        <th>6</th>
                    </tr>
                    <tr id="table-decryptors-row-caesar">
                        <td>a</td>
                        <td>b</td>
                        <td>c</td>
                        <td>d</td>
                        <td>e</td>
                        <td>f</td>
                    </tr>
                    <tr id="table-decryptors-row-vigenere-shift"></tr>
                    <tr id="table-decryptors-row-vigenere-deencryptor"></tr>
                    <tr id="table-decryptors-row-antiheader" class="font-size-small">
                        <th>-25</th>
                        <th>-24</th>
                        <th>-23</th>
                        <th>-22</th>
                        <th>-21</th>
                        <th>-20</th>
                    </tr>
                </table>
            </div>
            <div>
                <button id="button-refresh-lookup-table">🔄</button>
            </div>
        </div>
    </span>

    <div id="controls-all" class="controls">
        <div id="scytale-inputs-container" class="control-column mt-1 d-none">
            <div id="slider-scytale-single-container" class="control-column">
                <span class="mr-1">Skytale-Breite: <span id="slider-scytale-value-single">0</span></span>
                <input
                    class="flex-grow-1"
                    id="slider-scytale-single"
                    type="range"
                    min="1"
                    max="26"
                    value="1"
                />
            </div>
            <div id="slider-scytale-range-container" class="control-column">
                <span class="mr-1"
                    >Skytale-Breite: <span id="slider-scytale-value-start">0</span> bis
                    <span id="slider-scytale-value-end">0</span></span
                >
                <input
                    id="slider-scytale-range-start"
                    type="range"
                    min="1"
                    max="26"
                />
                <input
                    id="slider-scytale-range-end"
                    type="range"
                    min="1"
                    max="26"
                />
            </div>
        </div>

        <div id="caesar-inputs-container" class="control-column mt-1 d-none">
            <div id="slider-caesar-single-container" class="control-column">
                <span class="mr-1">Caesar-Versatz: <span id="slider-caesar-value-single">0</span></span>
                <input
                    class="flex-grow-1"
                    id="slider-caesar-single"
                    type="range"
                    min="0"
                    max="26"
                    value="3"
                />
            </div>
            <div id="slider-caesar-range-container" class="control-column">
                <span class="mr-1"
                    >Caesar-Versatz: <span id="slider-caesar-value-start">0</span> bis
                    <span id="slider-caesar-value-end">0</span></span
                >
                <input
                    id="slider-caesar-range-start"
                    type="range"
                    min="0"
                    max="26"
                />
                <input
                    id="slider-caesar-range-end"
                    type="range"
                    min="0"
                    max="26"
                />
            </div>

            <div id="caesar-advanced-container" class="control-column mt-2">
                <span class="control-row spread-end">
                    <span>Caesar-Zeichen:</span>
                    <div>
                        <!-- Hinzufügen -->
                        <button
                            id="button-caesar-add-characters-abc-lower"
                        >
                            abc
                        </button>
                        <button
                            id="button-caesar-add-characters-ABC-upper"
                        >
                            ABC
                        </button>
                        <button id="button-caesar-add-characters-123">
                            123
                        </button>
                    </div>
                </span>
                <textarea
                    id="caesar-deencryptor-input"
                    placeholder="Zeichen, durch die beim Ent- und Verschlüsseln rotiert wird. Zeichen, die nicht enthalten sind, werden nicht verändert. Standard: abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
                    rows="2"
                ></textarea>
            </div>
        </div>

        <div id="vigenere-inputs-container" class="control-column d-none">
            <span class="control-row">
                <span>Vigenère-Schlüssel:</span>
            </span>
            <textarea
                id="vigenere-key-input"
                rows="2"
            >abc</textarea>

            <div id="vigenere-advanced-container" class="control-column d-none">
                <div class="control-column mt-2">
                    <span class="control-row">
                        <span>Vigenère-Schlüsselzuordnung:</span>
                    </span>
                    <textarea
                        id="vigenere-shift-input"
                        placeholder="Legt fest, welches Zeichen wie weit verschiebt. Zeichen an Stelle n hier verschiebt um n. Bei Zeichen, die mehrfach hier stehen, zählt nur die erste Erwähnung. Checkbox 'Groß- Kleinschreibung ignorieren' wird hier ignoriert. Standard: abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
                        rows="3"
                    ></textarea>
                </div>

                <div class="control-column mt-2">
                    <span class="control-row spread-end">
                        <span>Vigenère-Zeichen:</span>
                        <div>
                            <!-- Hinzufügen -->
                            <button
                                id="button-vigenere-add-characters-abc-lower"
                            >
                                abc
                            </button>
                            <button
                                id="button-vigenere-add-characters-ABC-upper"
                            >
                                ABC
                            </button>
                            <button
                                id="button-vigenere-add-characters-123"
                            >
                                123
                            </button>
                        </div>
                    </span>
                    <textarea
                        id="vigenere-deencryptor-input"
                        placeholder="Zeichen, durch die beim Ent- und Verschlüsseln rotiert wird. Zeichen, die nicht enthalten sind, werden nicht verändert. Standard: abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
                        rows="2"
                    ></textarea>
                </div>
            </div>
        </div>

        <div id="evaluation-inputs-container" class="control-column d-none">
            <div id="evaluation-distance-container" class="control-column d-none">
                <span class="mr-1"
                    >Abstand: <span id="slider-evaluation-value-distance">0</span>, Anzeige:
                    <span id="slider-evaluation-value-display">alle</span></span
                >
                <input
                    id="slider-evaluation-distance"
                    type="range"
                    min="1"
                    max="25"
                    value="1"
                />
                <input
                    id="slider-evaluation-display"
                    type="range"
                    min="0"
                    max="25"
                    value="0"
                />
            </div>

            <div id="evaluation-advanced-container" class="control-column d-none">
                <div class="control-column mt-2">
                    <span class="control-row spread-end">
                        <span>Zählzeichen:</span>
                        <div>
                            <!-- Hinzufügen -->
                            <button
                                id="button-evaluation-add-characters-abc-lower"
                            >
                                abc
                            </button>
                            <button
                                id="button-evaluation-add-characters-ABC-upper"
                            >
                                ABC
                            </button>
                            <button
                                id="button-evaluation-add-characters-123"
                            >
                                123
                            </button>
                        </div>
                    </span>
                    <textarea
                        id="evaluation-labels-input"
                        placeholder="Zeichen, deren Häufigkeit in der Geheimbotschaft gezählt werden sollen. Standard: abcdefghijklmnopqrstuvwxyz"
                        rows="2"
                    ></textarea>
                </div>
            </div>
        </div>

        <div id="controls-checkboxes" class="mt-2">
            <div id="deencrypt-scytale-container" class="control-row d-none">
                <div class="check-radio-label">
                    <input type="radio" name="deencrypt-scytale" value="deencrypt-scytale-encrypt" disabled />
                    <label for="deencrypt-scytale-encrypt">Verschlüsseln</label>
                </div>
                <div class="check-radio-label">
                    <input
                        type="radio"
                        name="deencrypt-scytale"
                        value="deencrypt-scytale-decrypt"
                        disabled
                        checked
                    />
                    <label for="deencrypt-scytale-decrypt">Entschlüsseln</label>
                </div>
            </div>

            <div id="deencrypt-caesar-container" class="control-row d-none">
                <div class="check-radio-label">
                    <input
                        type="radio"
                        id="deencrypt-caesar-encrypt"
                        name="deencrypt-caesar"
                        value="deencrypt-caesar-encrypt"
                    />
                    <label for="deencrypt-caesar-encrypt">Verschlüsseln</label>
                </div>
                <div class="check-radio-label">
                    <input
                        type="radio"
                        id="deencrypt-caesar-decrypt"
                        name="deencrypt-caesar"
                        value="deencrypt-caesar-decrypt"
                        checked
                    />
                    <label for="deencrypt-caesar-decrypt">Entschlüsseln</label>
                </div>
            </div>

            <div id="deencrypt-vigenere-container" class="control-row d-none">
                <div class="check-radio-label">
                    <input
                        type="radio"
                        id="deencrypt-vigenere-encrypt"
                        name="deencrypt-vigenere"
                        value="deencrypt-vigenere-encrypt"
                    />
                    <label for="deencrypt-vigenere-encrypt">Verschlüsseln</label>
                </div>
                <div class="check-radio-label">
                    <input
                        type="radio"
                        id="deencrypt-vigenere-decrypt"
                        name="deencrypt-vigenere"
                        value="deencrypt-vigenere-decrypt"
                        checked
                    />
                    <label for="deencrypt-vigenere-decrypt">Entschlüsseln</label>
                </div>
            </div>

            <div id="checkboxes-scytale-container" class="control-column d-none">
                <div class="control-row">
                    <div class="check-radio-label">
                        <input
                            id="checkbox-scytale-slider-range"
                            type="checkbox"
                        />
                        <label for="checkbox-scytale-slider-range">Bereich auswählen</label>
                    </div>
                    <div class="check-radio-label">
                        <input
                            id="checkbox-scytale-mirror"
                            type="checkbox"
                        />
                        <label for="checkbox-scytale-mirror">Botschaft spiegeln</label>
                    </div>
                    <div class="check-radio-label">
                        <input
                            id="checkbox-scytale-connect"
                            type="checkbox"
                        />
                        <label for="checkbox-scytale-connect">Zeilen verbinden</label>
                    </div>
                    <div class="check-radio-label">
                        <input
                            id="checkbox-scytale-row-read-direction"
                            type="checkbox"
                        />
                        <label for="checkbox-scytale-row-read-direction">Zeilen Ordnung ändern</label>
                    </div>
                </div>
            </div>

            <div id="checkboxes-caesar-container" class="control-column d-none">
                <div class="control-row">
                    <div class="check-radio-label">
                        <input
                            id="checkbox-caesar-slider-range"
                            type="checkbox"
                        />
                        <label for="checkbox-caesar-slider-range">Bereich auswählen</label>
                    </div>
                    <div class="check-radio-label">
                        <input
                            id="checkbox-caesar-advanced"
                            type="checkbox"
                        />
                        <label for="checkbox-caesar-advanced">Fortgeschritten</label>
                    </div>
                </div>
            </div>

            <div id="checkboxes-vigenere-container" class="control-column d-none">
                <div class="control-row">
                    <div class="check-radio-label">
                        <input
                            id="checkbox-vigenere-check-permutations"
                            type="checkbox"
                        />
                        <label for="checkbox-vigenere-check-permutations">Schlüssel permutieren</label>
                    </div>
                    <div class="check-radio-label">
                        <input
                            id="checkbox-vigenere-advanced"
                            type="checkbox"
                        />
                        <label for="checkbox-vigenere-advanced">Fortgeschritten</label>
                    </div>
                    <div id="checkbox-vigenere-skip-unused-container" class="check-radio-label d-none">
                        <input
                            id="checkbox-vigenere-skip-unused"
                            type="checkbox"
                        />
                        <label for="checkbox-vigenere-skip-unused">Unbenutzte überspringen</label>
                    </div>
                </div>
            </div>

            <div id="checkboxes-evaluation-container" class="control-column d-none">
                <div class="control-row">
                    <div class="check-radio-label">
                        <input
                            id="checkbox-evaluation-distance"
                            type="checkbox"
                        />
                        <label for="checkbox-evaluation-distance">Abstand</label>
                    </div>
                    <div class="check-radio-label">
                        <input
                            id="checkbox-evaluation-labels-input"
                            type="checkbox"
                        />
                        <label for="checkbox-evaluation-labels-input">Zählzeichen</label>
                    </div>
                    <div class="check-radio-label">
                        <input
                            id="checkbox-evaluation-activate-animation"
                            type="checkbox"
                        />
                        <label for="checkbox-evaluation-activate-animation">Animation</label>
                    </div>
                    <div class="check-radio-label">
                        <input
                            id="checkbox-evaluation-count-rest"
                            type="checkbox"
                        />
                        <label for="checkbox-evaluation-count-rest">Sonstige zählen</label>
                    </div>
                    <div id="checkbox-evaluation-ignore-whitespace-container" class="check-radio-label d-none">
                        <input
                            id="checkbox-evaluation-ignore-whitespace"
                            type="checkbox"
                            checked
                        />
                        <label for="checkbox-evaluation-ignore-whitespace">Leerzeichen ignorieren</label>
                    </div>
                </div>
            </div>

            <div class="control-row">
                <div class="check-radio-label">
                    <input id="checkbox-caps" type="checkbox" checked />
                    <label for="checkbox-caps">Groß- / Kleinschreibung ignorieren</label>
                </div>
                <div class="check-radio-label">
                    <input
                        id="checkbox-autorun"
                        type="checkbox"
                        checked
                    />
                    <label for="checkbox-autorun">Automatisch aktualisieren</label>
                </div>
            </div>
        </div>
    </div>

    <span class="control-row">
        <div class="check-radio-label">
            <input id="checkbox-sidefill" type="checkbox" aria-label="Toggle full width"/>
            <!-- <label for="checkbox-sidefill">Side</label> -->
        </div>
        <button id="button-run" class="flex-grow-1">Los!</button>
        <div class="check-radio-label">
            <input id="checkbox-hide-controls" type="checkbox" aria-label="Toggle header and footer"/>
            <!-- <label for="checkbox-hide-controls">Hide</label> -->
        </div>
    </span>

    <span>
        Mehr Infos: <a href="https://de.wikipedia.org/wiki/Skytale" target="_blank">Skytale</a> &middot;
        <a href="https://de.wikipedia.org/wiki/Caesar-Verschl%C3%BCsselung" target="_blank">Caesar</a> &middot;
        <a href="https://de.wikipedia.org/wiki/Vigen%C3%A8re-Chiffre" target="_blank">Vigenère</a> &middot;
        <a
            href="https://de.wikipedia.org/wiki/Caesar-Verschl%C3%BCsselung#Entzifferung_und_Sicherheit"
            target="_blank"
            >Auswertung</a
        >
    </span>
</div>
